#include<bits/stdc++.h>
using namespace std;
vector<int> a[5005];
bool visited[5005];
int br[5005];
vector<int> t;
int p=0;
void dfs(int x){
    visited[x]=1;
    for(int i=0;i<a[x].size();i++){
        if(visited[a[x][i]]==0){
            p++;
        }
    }
    t.push_back(p);
}
int main(){
    int n,m;
    cin>>n>>m;
    for(int i=0;i<n;i++){
        int x,y;
        cin>>x>>y;
        a[x].push_back(i);
        a[y].push_back(i);
    }
    dfs(1);
    int brn=0;
    for(int i=0;i<t.size();i++){
        if(t[i]%2==1){
            brn++;
        }
    }
    cout<<(n-brn)/2;
return 0;
}
